Index: res/res_config_odbc.c
===================================================================
--- res/res_config_odbc.c	(wersja 410444)
+++ res/res_config_odbc.c	(kopia robocza)
@@ -484,8 +484,8 @@
 	SQLHSTMT stmt;
 	char sql[256];
 	SQLLEN rowcount=0;
-	const char *newparam;
-	int res, count = 1;
+	const char *newparam, *newval;
+	int res, count = 0;
 	va_list aq;
 	struct custom_prepare_struct cps = { .sql = sql, .extra = lookup };
 	struct odbc_cache_tables *tableptr;
@@ -516,30 +516,30 @@
 		ast_string_field_free_memory(&cps);
 		return -1;
 	}
-	va_arg(aq, const char *);
 
-	if (tableptr && !ast_odbc_find_column(tableptr, newparam)) {
-		ast_log(LOG_WARNING, "Key field '%s' does not exist in table '%s@%s'.  Update will fail\n", newparam, table, database);
+	if (tableptr && !ast_odbc_find_column(tableptr, keyfield)) {
+		ast_log(LOG_WARNING, "Key field '%s' does not exist in table '%s@%s'.  Update will fail\n", keyfield, table, database);
 	}
 
-	snprintf(sql, sizeof(sql), "UPDATE %s SET %s=?", table, newparam);
-	while((newparam = va_arg(aq, const char *))) {
-		va_arg(aq, const char *);
+	snprintf(sql, sizeof(sql), "UPDATE %s SET ", table);
+	while(newparam) {
+		newval = va_arg(aq, const char *);
 		if ((tableptr && (column = ast_odbc_find_column(tableptr, newparam))) || count > 63) {
 			/* NULL test for integer-based columns */
-			if (ast_strlen_zero(newparam) && tableptr && column && column->nullable && count < 64 &&
+			if (ast_strlen_zero(newval) && tableptr && column && column->nullable && count < 64 &&
 				(column->type == SQL_INTEGER || column->type == SQL_BIGINT ||
 				 column->type == SQL_SMALLINT || column->type == SQL_TINYINT ||
 				 column->type == SQL_NUMERIC || column->type == SQL_DECIMAL)) {
-				snprintf(sql + strlen(sql), sizeof(sql) - strlen(sql), ", %s=NULL", newparam);
+				snprintf(sql + strlen(sql), sizeof(sql) - strlen(sql), count ? ", %s=NULL" : " %s=NULL", newparam);
 				cps.skip |= (1LL << count);
 			} else {
-				snprintf(sql + strlen(sql), sizeof(sql) - strlen(sql), ", %s=?", newparam);
+				snprintf(sql + strlen(sql), sizeof(sql) - strlen(sql), count ? ", %s=?" : " %s=?", newparam);
 			}
 		} else { /* the column does not exist in the table */
 			cps.skip |= (1LL << count);
 		}
-		count++;
+		++count;
+		newparam = va_arg(aq, const char *);
 	}
 	va_end(aq);
 	snprintf(sql + strlen(sql), sizeof(sql) - strlen(sql), " WHERE %s=?", keyfield);
